# Keystore API

Every node has a built-in keystore. Clients create users on the keystore, which act as identities to be used when interacting with blockchains. A keystore exists at the node level, so if you create a user on a node it exists *only* on that node. However, users may be imported and exported using this API.

&#x20;**You should only create a keystore user on a node that you operate, as the node operator has access to your plaintext password.**

### Path <a href="#endpoint" id="endpoint"></a>

```
/ext/keystore
```

### **Example** Method <a href="#methods" id="methods"></a>

#### keystore.createUser <a href="#keystorecreateuser" id="keystorecreateuser"></a>

Create a new user with the specified username and password.

{% hint style="info" %}
Your request will be rejected if the password is too weak. The password should be at least 8 characters and contain upper and lower case letters as well as numbers and symbols. It should not contain the word "Password".
{% endhint %}

### **Example Call**

```
//Request
curl -X POST --data '{
    "jsonrpc":"2.0",
    "id"     :1,
    "method" :"keystore.createUser",
    "params" :{
        "username":"test",
        "password":"Test1234!"
    }
}' -H 'content-type:application/json;' https://ava-api.bwarelabs.com/<your-endpoint-id>/ext/keystore

//Response
{
    "jsonrpc":"2.0",
    "id"     :1,
    "result" :{
        "success":true
    }
}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.bwarelabs.com/api-docs/avalanche-api/keystore-api.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
